Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs	(revision 14513)
@@ -1,345 +1,358 @@
-﻿using System;
-using HeuristicLab.Algorithms.PushGP.Expressions;
-using HeuristicLab.Algorithms.PushGP.Stack;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
-
-namespace HeuristicLab.Tests.Interpreter.Expressions
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions
 {
-    [TestClass]
-    public class FloatExpressionTests : CommonTests<double>
-    {
-        private const double delta = 0.00001;
-        protected override string TypeName { get { return "FLOAT"; } }
-        protected override IStack<double> Stack { get { return interpreter.FloatStack; } }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestAdd()
-        {
-            interpreter.FloatStack.Push(5.3, 5.3);
-            interpreter.Interpret(new FloatAddExpression());
-
-            Assert.AreEqual(10.6, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestAddWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("+", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestSubtract()
-        {
-            interpreter.FloatStack.Push(10.2, 5.3);
-            interpreter.Interpret(new FloatSubtractExpression());
-
-            Assert.AreEqual(4.9, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestSubractWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("-", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestMultiply()
-        {
-            interpreter.FloatStack.Push(9.9, 3.3);
-            interpreter.Interpret(new FloatMultiplyExpression());
-
-            Assert.AreEqual(32.67, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestMultiplyWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("*", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestDivide()
-        {
-            interpreter.FloatStack.Push(9.9, 3.3);
-            interpreter.Interpret(new FloatDivideExpression());
-
-            Assert.AreEqual(3.0, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestDivideWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("/", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestModulo()
-        {
-            interpreter.FloatStack.Push(11.6, 5.3);
-            interpreter.Interpret(new FloatModuloExpression());
-
-            Assert.AreEqual(1, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestModuloWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("%", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestMin()
-        {
-            interpreter.FloatStack.Push(10.2, 5.3);
-            interpreter.Interpret(new FloatMinExpression());
-
-            Assert.AreEqual(5.3, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestMinWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("MIN", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestMax()
-        {
-            interpreter.FloatStack.Push(10.3, 5.3);
-            interpreter.Interpret(new FloatMaxExpression());
-
-            Assert.AreEqual(10.3, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestMaxWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("MAX", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestSmallerThan()
-        {
-            interpreter.FloatStack.Push(10.2, 5.3);
-            interpreter.Interpret(new FloatSmallerThanExpression());
-
-            Assert.AreEqual(false, interpreter.BooleanStack.Top);
-
-            TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestSmallerThanWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("<", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestGreaterThan()
-        {
-            interpreter.FloatStack.Push(10.2, 5.3);
-            interpreter.Interpret(new FloatGreaterThanExpression());
-
-            Assert.AreEqual(true, interpreter.BooleanStack.Top);
-
-            TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestGreaterThanWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments(">", 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestFromBooleanTrue()
-        {
-            interpreter.BooleanStack.Push(true);
-            interpreter.Interpret(new FloatFromBooleanExpression());
-
-            Assert.AreEqual(1d, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestFromBooleanFalse()
-        {
-            interpreter.BooleanStack.Push(false);
-            interpreter.Interpret(new FloatFromBooleanExpression());
-
-            Assert.AreEqual(0d, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestFromBooleanWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("FROMBOOLEAN");
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestFromInteger()
-        {
-            interpreter.IntegerStack.Push(5);
-            interpreter.Interpret(new FloatFromIntegerExpression());
-
-            Assert.AreEqual(5d, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestFromIntegerWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("FROMINTEGER");
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestSine()
-        {
-            interpreter.FloatStack.Push(Math.PI / 2);
-            interpreter.Interpret(new FloatSineExpression());
-
-            Assert.AreEqual(1, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestSineWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("SIN");
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestCosine()
-        {
-            interpreter.FloatStack.Push(Math.PI);
-            interpreter.Interpret(new FloatCosineExpression());
-
-            Assert.AreEqual(-1, interpreter.FloatStack.Top, delta);
-
-            TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
-        [TestProperty("Time", "Short")]
-        [TestCategory("ExpressionTest")]
-        [TestCategory("FloatExpressionTest")]
-        public void TestCosineWithInsufficientArguments()
-        {
-            TestWithInsufficientArguments("COS");
-        }
-
-        protected override double[] GetValues(int count)
-        {
-            var values = new double[count];
-
-            for (var i = 0; i < count; i++)
-            {
-                values[i] = i * 0.9;
-            }
-
-            return values;
-        }
-
-        protected override void CheckOtherStacksAreEmpty()
-        {
-            TestStackCounts(floatStack: null);
-        }
-    }
+  using System;
+
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Stack;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class FloatExpressionTests : CommonTests<double>
+  {
+    private const double delta = 0.00001;
+
+    protected override string TypeName
+    {
+      get
+      {
+        return "FLOAT";
+      }
+    }
+
+    protected override IStack<double> Stack
+    {
+      get
+      {
+        return this.interpreter.FloatStack;
+      }
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestAdd()
+    {
+      this.interpreter.FloatStack.Push(5.3, 5.3);
+      this.interpreter.Interpret(new FloatAddExpression());
+
+      Assert.AreEqual(10.6, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestAddWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("+", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestSubtract()
+    {
+      this.interpreter.FloatStack.Push(10.2, 5.3);
+      this.interpreter.Interpret(new FloatSubtractExpression());
+
+      Assert.AreEqual(4.9, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestSubractWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("-", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestMultiply()
+    {
+      this.interpreter.FloatStack.Push(9.9, 3.3);
+      this.interpreter.Interpret(new FloatMultiplyExpression());
+
+      Assert.AreEqual(32.67, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestMultiplyWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("*", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestDivide()
+    {
+      this.interpreter.FloatStack.Push(9.9, 3.3);
+      this.interpreter.Interpret(new FloatDivideExpression());
+
+      Assert.AreEqual(3.0, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestDivideWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("/", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestModulo()
+    {
+      this.interpreter.FloatStack.Push(11.6, 5.3);
+      this.interpreter.Interpret(new FloatModuloExpression());
+
+      Assert.AreEqual(1, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestModuloWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("%", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestMin()
+    {
+      this.interpreter.FloatStack.Push(10.2, 5.3);
+      this.interpreter.Interpret(new FloatMinExpression());
+
+      Assert.AreEqual(5.3, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestMinWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("MIN", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestMax()
+    {
+      this.interpreter.FloatStack.Push(10.3, 5.3);
+      this.interpreter.Interpret(new FloatMaxExpression());
+
+      Assert.AreEqual(10.3, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestMaxWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("MAX", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestSmallerThan()
+    {
+      this.interpreter.FloatStack.Push(10.2, 5.3);
+      this.interpreter.Interpret(new FloatSmallerThanExpression());
+
+      Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
+
+      this.TestStackCounts(booleanStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestSmallerThanWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("<", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestGreaterThan()
+    {
+      this.interpreter.FloatStack.Push(10.2, 5.3);
+      this.interpreter.Interpret(new FloatGreaterThanExpression());
+
+      Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
+
+      this.TestStackCounts(booleanStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestGreaterThanWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments(">", 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestFromBooleanTrue()
+    {
+      this.interpreter.BooleanStack.Push(true);
+      this.interpreter.Interpret(new FloatFromBooleanExpression());
+
+      Assert.AreEqual(1d, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestFromBooleanFalse()
+    {
+      this.interpreter.BooleanStack.Push(false);
+      this.interpreter.Interpret(new FloatFromBooleanExpression());
+
+      Assert.AreEqual(0d, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestFromBooleanWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("FROMBOOLEAN");
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestFromInteger()
+    {
+      this.interpreter.IntegerStack.Push(5);
+      this.interpreter.Interpret(new FloatFromIntegerExpression());
+
+      Assert.AreEqual(5d, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestFromIntegerWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("FROMINTEGER");
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestSine()
+    {
+      this.interpreter.FloatStack.Push(Math.PI / 2);
+      this.interpreter.Interpret(new FloatSineExpression());
+
+      Assert.AreEqual(1, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestSineWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("SIN");
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestCosine()
+    {
+      this.interpreter.FloatStack.Push(Math.PI);
+      this.interpreter.Interpret(new FloatCosineExpression());
+
+      Assert.AreEqual(-1, this.interpreter.FloatStack.Top, delta);
+
+      this.TestStackCounts(floatStack: 1);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("FloatExpressionTest")]
+    public void TestCosineWithInsufficientArguments()
+    {
+      this.TestWithInsufficientArguments("COS");
+    }
+
+    protected override double[] GetValues(int count)
+    {
+      var values = new double[count];
+
+      for (var i = 0; i < count; i++) values[i] = i * 0.9;
+
+      return values;
+    }
+
+    protected override void CheckOtherStacksAreEmpty()
+    {
+      this.TestStackCounts(floatStack: null);
+    }
+  }
 }
